//-------------------------------------------------------------------------------------------------
// <copyright file="SAObject.cs" company="OfficeClip LLC">
// Copyright (c) OfficeClip LLC.  All rights reserved.
// </copyright>
//-------------------------------------------------------------------------------------------------

namespace OfficeClip.OpenSource.StyleFix
{
    /// <summary>
    /// The Container for the StyleCop Analysis Object
    /// </summary>
    public class SAObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SAObject"/> class.
        /// </summary>
        /// <param name="fileName">Name of the file.</param>
        /// <param name="errorId">The error id.</param>
        /// <param name="lineNumber">The line number.</param>
        /// <param name="description">The description.</param>
        public SAObject(string fileName, string errorId, int lineNumber, string description)
        {
            this.FileName = fileName;
            this.ErrorId = errorId;
            this.LineNumber = lineNumber;
            this.Description = description;
        }

        /// <summary>
        /// Gets or sets the name of the file.
        /// </summary>
        /// <value>The name of the file.</value>
        public string FileName { get; set; }

        /// <summary>
        /// Gets or sets the error id.
        /// </summary>
        /// <value>The error id.</value>
        public string ErrorId { get; set; }

        /// <summary>
        /// Gets or sets the line number.
        /// </summary>
        /// <value>The line number.</value>
        public int LineNumber { get; set; }

        /// <summary>
        /// Gets or sets the description.
        /// </summary>
        /// <value>The description.</value>
        public string Description { get; set; }
    }
}
