﻿using OfficeClip.OpenSource.StyleFix.Drivers;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using OfficeClip.OpenSource.StyleFix;
using System.Collections.Generic;

namespace StyleFixUnitTest
{
    
    
    /// <summary>
    ///This is a test class for DocumentationRulesTest and is intended
    ///to contain all DocumentationRulesTest Unit Tests
    ///</summary>
    [TestClass()]
    public class DocumentationRulesTest
    {


        private TestContext testContextInstance;
        private SAObject saObject;
        private List<SAObject> saObjects;
        private DocumentationRules target;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        public DocumentationRulesTest()
        {
            target = new DocumentationRules();
            target.ForceAllow = true;
            saObject = new SAObject(string.Empty, 1, 1, string.Empty, false);
        }

        /// <summary>
        ///A test for SA1633_FileMustHaveHeader
        ///</summary>
        [TestMethod()]
        public void SA1633_FileMustHaveHeaderTest()
        {
            saObject.ErrorId = "1633";
            
            string fileName = "test.aspx.cs"; 
            string outputLines = "using xyz";
            string outputExpected = @"// <copyright file=""test.aspx.cs""";
             target.SA1633_FileMustHaveHeader(fileName, ref outputLines);
             string[] actualOutput = outputLines.Split(System.Environment.NewLine.ToCharArray());
            Assert.IsTrue(actualOutput[2].StartsWith(outputExpected));
        }
    }
}
