﻿using OfficeClip.OpenSource.StyleFix.Drivers;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using OfficeClip.OpenSource.StyleFix;
using System.Collections.Generic;

namespace StyleFixUnitTest
{
    
    
    /// <summary>
    ///This is a test class for NamingRulesTest and is intended
    ///to contain all NamingRulesTest Unit Tests
    ///</summary>
    [TestClass()]
    public class NamingRulesTest
    {
        private TestContext testContextInstance;
        private NamingRules target;
        private SAObject saObject;
        private List<SAObject> saObjects;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        public NamingRulesTest()
        {
            target = new NamingRules();
            target.ForceAllow = true;
            saObject = new SAObject(string.Empty, 1, 1, string.Empty, false);
        }

        /// <summary>
        ///A test for SA1300_ElementMustBeginWithUpperCaseLetter
        ///</summary>
        [TestMethod()]
        public void SA1300_ElementMustBeginWithUpperCaseLetter()
        {
            List<SFWorkingLine> workingLines = new List<SFWorkingLine>();
            saObjects = new List<SAObject>();
            saObject.ErrorId = "SA1300";
            saObject.Description = "method names begin with an upper-case letter: testMethod.";
            saObjects.Add(saObject);
            // test catch
            SFWorkingLine workingLine = new SFWorkingLine(1, "        void testMethod()", false, saObjects);
            workingLines.Add(workingLine);
            List<SFWorkingLine> workingLinesExpected = new List<SFWorkingLine>();
            SFWorkingLine workingLineExpected = new SFWorkingLine(1, "        void TestMethod()", false, saObjects);
            workingLinesExpected.Add(workingLineExpected);
            // run code
            target.SA1300_ElementMustBeginWithUpperCaseLetter(ref workingLines);
            // asserts
            Assert.AreEqual(workingLinesExpected[0].Line, workingLines[0].Line);          
        }
    }
}
