//-------------------------------------------------------------------------------------------------
// <copyright file="Utility.cs" company="OfficeClip LLC">
// Copyright (c) OfficeClip LLC.  All rights reserved.
// </copyright>
//-------------------------------------------------------------------------------------------------
namespace OfficeClip.OpenSource.StyleFix
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics;
    using System.IO;
    using System.Text;

    public class Utility
    {
        public string GetSetupDir()
        {
            System.Reflection.Assembly Asm = System.Reflection.Assembly.GetExecutingAssembly();
            return Path.GetDirectoryName(Asm.Location);
        }

        public string Run(string dir, string programPath, string processArgument, string filePath)
        {
            string retVal = string.Empty;
            try
            {
                ProcessStartInfo processStartInfo = new ProcessStartInfo(
                    string.Format(@"{0}\{1}", dir, programPath));

                processStartInfo.Arguments = string.Format(
                    @"{0} ""{1}""", processArgument, filePath);

                processStartInfo.UseShellExecute = false;
                processStartInfo.ErrorDialog = false;
                processStartInfo.CreateNoWindow = true;
                processStartInfo.RedirectStandardError = true;
                processStartInfo.RedirectStandardOutput = false;
                processStartInfo.RedirectStandardInput = false;

                Process proc = new Process();
                proc.StartInfo = processStartInfo;
                bool started = proc.Start();
                if (started)
                {
                    retVal = proc.StandardError.ReadToEnd();
                    if (retVal != string.Empty)
                    {
                        retVal = string.Format("{1}AStyle: {0}{1}", retVal, System.Environment.NewLine);
                    }

                    proc.WaitForExit(7000);
                }
            }
            catch (Exception e)
            {
                retVal = string.Format("{1}AStyle: {0}{1}", e.Message, System.Environment.NewLine);
            }

            return retVal;
        }
    }
}